export type Pred<T, K> = (input: T) => K;
export type PredIndexed<T, K> = (input: T, index: number, array: Array<T>) => K;
export type PredIndexedOptional<T, K> = (input: T, index?: number, array?: Array<T>) => K;
export type NonEmptyArray<T> = [T, ...Array<T>];
export type IterableContainer<T = unknown> = ReadonlyArray<T> | [];
export type ObjectKeys<T extends object> = `${Exclude<keyof T, symbol>}`;
export type ReadonlyTuple<Element, Length extends number> = number extends Length ? ReadonlyArray<Element> : BuildTupleHelper<Element, Length, []>;
export type NarrowedTo<T, Base> = Extract<T, Base> extends never ? Base : Extract<T, Base>;
type BuildTupleHelper<Element, Length extends number, Rest extends Array<Element>> = Rest['length'] extends Length ? readonly [...Rest] : BuildTupleHelper<Element, Length, [Element, ...Rest]>;
export type IfIsAny<T, Then, Else> = 0 extends 1 & T ? Then : Else;
export {};
//# sourceMappingURL=_types.d.ts.map