type Debouncer<F extends (...args: any) => unknown, IsNullable extends boolean = true> = {
    readonly call: (...args: Parameters<F>) => ReturnType<F> | (true extends IsNullable ? undefined : never);
    readonly cancel: () => void;
    readonly flush: () => ReturnType<F> | undefined;
    readonly isPending: boolean;
    readonly cachedValue: ReturnType<F> | undefined;
};
type DebounceOptions = {
    readonly waitMs?: number;
    readonly maxWaitMs?: number;
};
export declare function debounce<F extends (...args: any) => any>(func: F, options: {
    readonly timing?: 'trailing';
} & DebounceOptions): Debouncer<F>;
export declare function debounce<F extends (...args: any) => any>(func: F, options: ({
    readonly timing: 'leading';
} & Omit<DebounceOptions, 'maxWaitMs'>) | ({
    readonly timing: 'both';
} & DebounceOptions)): Debouncer<F, false>;
export {};
//# sourceMappingURL=debounce.d.ts.map