import type { ConditionalSimplifyDeep } from './conditional-simplify';
import type { Merge } from './merge';
import type { OmitIndexSignature } from './omit-index-signature';
import type { PickIndexSignature } from './pick-index-signature';
type UnknownRecord = Record<string, unknown>;
type SimplifyDeep<Type> = ConditionalSimplifyDeep<Type, Function | Iterable<unknown>, object>;
type MergeDeepRecordProperty<Destination, Source> = undefined extends Source ? MergeDeepOrReturn<Source, Exclude<Destination, undefined>, Exclude<Source, undefined>> | undefined : MergeDeepOrReturn<Source, Destination, Source>;
type DoMergeDeepRecord<Destination extends UnknownRecord, Source extends UnknownRecord> = {
    [Key in keyof Destination as Key extends keyof Source ? never : Key]: Destination[Key];
} & {
    [Key in keyof Source as Key extends keyof Destination ? never : Key]: Source[Key];
} & {
    [Key in keyof Source as Key extends keyof Destination ? Key : never]: MergeDeepRecordProperty<Key extends keyof Destination ? Destination[Key] : never, Source[Key]>;
};
type MergeDeepRecord<Destination extends UnknownRecord, Source extends UnknownRecord> = DoMergeDeepRecord<OmitIndexSignature<Destination>, OmitIndexSignature<Source>> & Merge<PickIndexSignature<Destination>, PickIndexSignature<Source>>;
type MergeDeepOrReturn<DefaultType, Destination, Source> = SimplifyDeep<[
    undefined
] extends [Destination | Source] ? DefaultType : Destination extends UnknownRecord ? Source extends UnknownRecord ? MergeDeepRecord<Destination, Source> : DefaultType : DefaultType>;
export type MergeDeep<Destination extends UnknownRecord, Source extends UnknownRecord> = SimplifyDeep<MergeDeepRecord<SimplifyDeep<Destination>, SimplifyDeep<Source>>>;
export {};
//# sourceMappingURL=merge-deep.d.ts.map